
#include "distortion.h"

extern float distanceMeasure(int level, int noOfLevel);
extern float distanceMeasureTotal(int noOfLevel);

double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
{
	double returnValue;
	double currDist, currDist2;
	int i, j, k;
	int noOfDim;
	int noOfLevel;
	int currLevel;
	equivalenceTuple **eqTuple;

	equivalenceTuple *eqOne;

	returnValue = 0;

	// assume the last dim is the sensitive attr
	noOfDim = config->noOfDim - 1;
	eqTuple = eqClass->eqClass;

	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		//eqOne = &(eqTuple[i]);
		eqOne = eqTuple[i];

		currDist = 0.0;
		for (j = 0; j < noOfDim; j++)
		{
			noOfLevel = genAllTable->genDimTable[j].noOfLevel;
			currLevel = eqOne->content[j].level;

			currDist2 = 0.0;
			//currDist2 += currLevel/((double)noOfLevel-1.0);
			for (k = 0; k < currLevel; k++)
			{
				currDist2 += distanceMeasure(k, noOfLevel);
			}
			currDist2 /= ((float) distanceMeasureTotal(noOfLevel));

			currDist += currDist2;
			
		}
		currDist *= eqOne->noOfMember;
		//currDist *- eqOne->noOfSen;

		returnValue += currDist;
	}
//printf("%.4f\n", returnValue);
	return returnValue;
}


double calculateSenDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
{
	double returnValue;
	double currDist, currDist2;
	int i, j, k;
	int noOfDim;
	int noOfLevel;
	int currLevel;
	equivalenceTuple **eqTuple;

	equivalenceTuple *eqOne;

	returnValue = 0;

	// assume the last dim is the sensitive attr
	noOfDim = config->noOfDim - 1;
	eqTuple = eqClass->eqClass;

	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		//eqOne = &(eqTuple[i]);
		eqOne = eqTuple[i];

		currDist = 0.0;
		for (j = 0; j < noOfDim; j++)
		{
			noOfLevel = genAllTable->genDimTable[j].noOfLevel;
			currLevel = eqOne->content[j].level;

			currDist2 = 0.0;
			//currDist2 += currLevel/((double)noOfLevel-1.0);
			for (k = 0; k < currLevel; k++)
			{
				currDist2 += distanceMeasure(k, noOfLevel);
			}
			currDist2 /= ((float) distanceMeasureTotal(noOfLevel));

			currDist += currDist2;
			
		}
		//currDist *= eqOne->noOfMember;
		currDist *= eqOne->noOfSen;

		returnValue += currDist;
	}
//printf("%.4f\n", returnValue);
	return returnValue;
}

